package com.synjones.charge.service.impl;

package ..deTemp.1737101782293;

import com.alibaba.fastjson.JSON;
import com.synjones.charge.bean.FeeitemImplBean;
import com.synjones.charge.bean.OrderBean;
import com.synjones.charge.bean.PayBean;
import com.synjones.charge.bean.UserBean;
import com.synjones.charge.common.utils.HttpClientUtil;
import com.synjones.charge.common.utils.UserUtilUnify;
import com.synjones.charge.dao.IPayDao;
import com.synjones.charge.service.IIECService;
import com.synjones.charge.service.impl.IECServiceImpl;
import com.synjones.core.tool.exception.ServiceException;
import com.synjones.core.tool.jackson.JsonUtil;
import com.synjones.core.tool.utils.Func;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Arrays;
import java.util.Base64;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.redis.core.HashOperations;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

@Service("iECCxlibServiceImpl")
public class IECCxlibServiceImpl extends IECServiceImpl implements IIECService {
  private static final Logger log = LoggerFactory.getLogger(com.synjones.charge.service.impl.IECCxlibServiceImpl.class);
  
  private UserUtilUnify userUtilUnify;
  
  private RedisTemplate<String, ?> redisTemplate;
  
  private IPayDao payDao;
  
  private static final String redisKey = "IEC:CX_Library:";
  
  public IECCxlibServiceImpl(UserUtilUnify userUtilUnify, RedisTemplate<String, ?> redisTemplate, IPayDao payDao) {
    this.userUtilUnify = userUtilUnify;
    this.redisTemplate = redisTemplate;
    this.payDao = payDao;
  }
  
  public Map<String, Object> getThirdData(Map<String, Object> params) throws Exception {
    log.info("CxLibrary-param:{}", JSON.toJSONString(params));
    Map<String, Object> resultMap = new HashMap<>();
    if (!Func.isEmpty(params.get("type")) && !Func.isEmpty(params.get("level"))) {
      FeeitemImplBean itemimpl = (FeeitemImplBean)params.get("feeitemImpl");
      String type = params.get("type").toString();
      String[] total = null;
      if (Func.isNotEmpty(params.get("interfacechoice")))
        total = Func.toStr(params.get("interfacechoice")).split(","); 
      if ("select".equalsIgnoreCase(type)) {
        Map<String, Object> result = new HashMap<>();
        if (Func.isNotEmpty((Object[])total))
          result.put("total", getTotal(total)); 
        return result;
      } 
      if ("IEC".equals(type)) {
        Map<String, Object> usermap = this.userUtilUnify.getUser();
        String sno = Func.toStr(usermap.get("sno"));
        if (Func.isNotEmpty(params.get("sno")))
          sno = params.get("sno").toString(); 
        Map<String, Object> showData = new LinkedHashMap<>();
        Map<String, Object> dataMap = new HashMap<>();
        String url = itemimpl.getUrl() + "/open/user/getUserOverDueDetail";
        Map<String, String> header = new HashMap<>();
        header.put("Authorization", "Bearer " + getToken(itemimpl));
        Map<String, String> param = new HashMap<>();
        param.put("primaryId", sno);
        log.info("CxLibrary-requesturl:{},param:{}", url, JSON.toJSONString(param));
        String doSearchdebt = HttpClientUtil.httpGet(url, param, "UTF-8", header);
        log.info("CxLibrary-answer:" + doSearchdebt);
        Map<String, Object> mapSearchdebt = JsonUtil.toMap(doSearchdebt);
        String tipinfo = "";
        if (!Func.isEmpty(mapSearchdebt)) {
          if (Func.toBoolean(mapSearchdebt.get("success")).booleanValue() && Func.isNotEmpty(mapSearchdebt.get("data"))) {
            Map<String, Object> data = (Map<String, Object>)mapSearchdebt.get("data");
            String totaldebt = Func.toStr(data.get("duePay"));
            BigDecimal totalprice = new BigDecimal(totaldebt);
            if (totalprice.compareTo(BigDecimal.ZERO) > 0) {
              List<Map<String, Object>> debtdetailslist = (List<Map<String, Object>>)data.get("list");
              if (!Func.isEmpty(debtdetailslist) && debtdetailslist.size() > 0) {
                String detail = "";
                String tranids = "";
                for (int u = 0; u < debtdetailslist.size(); u++) {
                  Map<String, Object> detailmap = debtdetailslist.get(u);
                  double fee = Double.parseDouble(Func.toStr(detailmap.get("dueDebt")));
                  String title = Func.toStr(detailmap.get("behaviourName"));
                  detail = detail + title + "-" + fee;
                  if (u != debtdetailslist.size() - 1) {
                    detail = detail + ";<br/>";
                  } else {
                    detail = detail + "。";
                  } 
                  if (u == 0) {
                    tranids = Func.toStr(detailmap.get("behaviourDetailId"));
                  } else {
                    tranids = tranids + "," + detailmap.get("behaviourDetailId");
                  } 
                } 
                showData.put("详情", detail);
                dataMap.put("behaviourDeatilIds", tranids);
                dataMap.put("totaldebt", totalprice);
                dataMap.put("primaryId", sno);
                log.info("---duePay-----" + totalprice);
                resultMap.put("iectranamt", totalprice);
              } else {
                tipinfo = "未获取到欠费信息。";
                Map<String, Object> implvalues = JsonUtil.toMap(itemimpl.getValue());
                if (!Func.isEmpty(implvalues.get("tipinfo")))
                  tipinfo = Func.toStr(implvalues.get("tipinfo")); 
              } 
            } else {
              tipinfo = "欠费金额不大于0，无需缴费";
            } 
          } else if (Func.isNotEmpty(mapSearchdebt.get("message"))) {
            tipinfo = Func.toStr(mapSearchdebt.get("message"));
          } 
        } else {
          log.info("---get false---");
          tipinfo = "获取到欠费信息返回false。";
        } 
        if (!Func.isEmpty(tipinfo)) {
          resultMap.put("feeFlag", Integer.valueOf(0));
          resultMap.put("tipinfo", tipinfo);
          return resultMap;
        } 
        resultMap.put("data", dataMap);
        resultMap.put("showData", showData);
      } else {
        log.info("———————————————————CxLib———————type-level--ERROR--");
      } 
    } 
    return resultMap;
  }
  
  public Map<String, Object> setEleData(UserBean user, OrderBean orderBean) throws Exception {
    Map<String, Object> thirdMap = JsonUtil.toMap(orderBean.getThird_party());
    FeeitemImplBean itemimpl = orderBean.getFeeitemImplBean();
    String url = itemimpl.getUrl() + "/open/user/payForUserOverDueDetail";
    String[] behaviourDeatilIds = Func.toStr(thirdMap.get("behaviourDeatilIds")).split(",");
    log.info("CxLibrary-behaviourDeatilIds:{}", JSON.toJSONString(behaviourDeatilIds));
    int[] intArray = Arrays.<String>stream(behaviourDeatilIds).mapToInt(Integer::parseInt).toArray();
    String payCode = "3";
    PayBean pay = (PayBean)this.payDao.selectById(orderBean.getPayid());
    if (Func.isNotEmpty(pay))
      if (pay.getCode().contains("WEIXIN") || (Func.isNotEmpty(pay.getRemark()) && pay.getRemark().contains("weixin"))) {
        payCode = "6";
      } else if (pay.getCode().contains("ALIPAY") || (Func.isNotEmpty(pay.getRemark()) && pay.getRemark().contains("alipay"))) {
        payCode = "5";
      } else if (Func.isNotEmpty(pay.getRemark()) && pay.getRemark().contains("unionpay")) {
        payCode = "7";
      }  
    Map<String, String> header = new HashMap<>();
    log.info("CxLibrary-setEleData url:{}", url);
    header.put("Authorization", "Bearer " + getToken(itemimpl));
    header.put("Content-Type", " application/json;charset=UTF-8");
    Map<String, Object> param = new HashMap<>();
    param.put("primaryId", Func.toStr(thirdMap.get("primaryId")));
    param.put("payCode", payCode);
    param.put("behaviourDeatillds", intArray);
    log.info("CxLibrary-setEleData param:{}", JSON.toJSONString(param));
    String doPaymoney = HttpClientUtil.doPost(url, param, header);
    log.info("CxLibrary-setEleData-answer:" + doPaymoney);
    if (!Func.isEmpty(doPaymoney)) {
      Map<String, Object> mapPaymoney = JsonUtil.toMap(doPaymoney);
      if (Func.toBoolean(mapPaymoney.get("success")).booleanValue()) {
        thirdMap.put("thirdBackData", doPaymoney);
        return thirdMap;
      } 
    } 
    return null;
  }
  
  private String getToken(FeeitemImplBean itemimpl) {
    String token = "";
    try {
      String key = "IEC:CX_Library:CxLibrary_token";
      String key2 = "CxLibrary";
      boolean hasKey = this.redisTemplate.hasKey(key).booleanValue();
      HashOperations<String, String, String> operations = this.redisTemplate.opsForHash();
      if (hasKey) {
        token = Func.toStr(operations.get(key, key2));
      } else {
        Map<String, Object> implValues = JsonUtil.toMap(itemimpl.getValue());
        String clientId = Func.toStr(implValues.get("clientId"));
        String clientSecret = Func.toStr(implValues.get("clientSecret"));
        String url = itemimpl.getUrl() + "/oauth/token?grant_type=client_credentials&scope=x";
        log.info("CxLibrary-token-request:{}", url);
        String doGetToken = getTokenApi(url, clientId, clientSecret);
        log.info("CxLibrary-token-answer:" + doGetToken);
        Map<String, Object> map = JsonUtil.toMap(doGetToken);
        if (!Func.isEmpty(map.get("access_token"))) {
          token = Func.toStr(map.get("access_token"));
          long time = Func.toLong(map.get("expires_in"));
          int expiresIn = Func.toInt(Long.valueOf(time)) - 10;
          if (expiresIn > 0) {
            operations.put(key, key2, token);
            this.redisTemplate.expire(key, expiresIn, TimeUnit.SECONDS);
          } 
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
      log.error("获取token异常");
    } 
    if (Func.isEmpty(token))
      throw new ServiceException("获取token失败"); 
    return token;
  }
  
  public static String getTokenApi(String apiUrl, String clientId, String clientSecret) throws Exception {
    URL url = new URL(apiUrl);
    HttpURLConnection connection = (HttpURLConnection)url.openConnection();
    connection.setRequestMethod("POST");
    String auth = clientId + ":" + clientSecret;
    String encodedAuth = Base64.getEncoder().encodeToString(auth.getBytes());
    connection.setRequestProperty("Authorization", "Basic " + encodedAuth);
    connection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
    connection.setDoOutput(true);
    OutputStream os = connection.getOutputStream();
    os.flush();
    os.close();
    int responseCode = connection.getResponseCode();
    if (Func.isNotEmpty(Integer.valueOf(responseCode)) && responseCode == 200) {
      BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
      StringBuilder response = new StringBuilder();
      String inputLine;
      while ((inputLine = in.readLine()) != null)
        response.append(inputLine); 
      in.close();
      return response.toString();
    } 
    log.info("api-error==HTTP error code" + responseCode);
    throw new RuntimeException("Failed : HTTP error code : " + responseCode);
  }
}
